// Import PeasyCam
import peasy.*;
PeasyCam cam;

// Set the size of the box
int bWidth = 1600;
int bHeight = 1200;
int bDepth = 1000;

// Set the number of the line
int num = 256*20;

// Declare the arrays to store selected vertexs
PVector[] vertexs1, vertexs2;

void setup(){
  size(1920,1400,P3D);
  // Setup of the camera, the initial distance is 3000 by setting
  cam = new PeasyCam(this, 3000);
  // Set the zoom scale of the camera
  cam.setMinimumDistance(500);
  cam.setMaximumDistance(8000);
  // Initialize the arrays
  vertexs1 = new PVector[num];
  vertexs2 = new PVector[num];
  // For each PVector in the array, generate a position
  for(int i=0;i<num;i++){
    vertexs1[i] = selectvertex();
    vertexs2[i] = selectvertex();
  }
}


void draw(){
  background(220,220,220);
  // Set the color and strokeweight of the box's frame
  stroke(255,10,0);
  strokeWeight(3);
  noFill();
  // Plot the box
  box(bWidth,bHeight, bDepth);
  // Translate the axises for drawing the lines
  translate(-bWidth/2,-bHeight/2,-bDepth/2);
  // Set the strokeweigth of the lines
  strokeWeight(2);
  // For each pair of vertexes, set the color of the line and connect the pair
  for(int i = 0; i<num; i++){
    stroke(i%255,i%128);
    line(vertexs1[i].x,vertexs1[i].y,vertexs1[i].z,vertexs2[i].x,vertexs2[i].y,vertexs2[i].z);
  }
}
// A function that generate random points on the frame
PVector selectvertex(){
  // First, select a vertex from the eight
  PVector vertex = new PVector(int(random(0,2))*bWidth,int(random(0,2))*bHeight,int(random(0,2))*bDepth);
  // Select the axis that the vertex is going to move along
  int selectAxis = int(random(0,3));
  // If selecting x-axis, modify the x value
  if(selectAxis ==0){
    vertex.x = random(0, bWidth);}
  // If selecting y-axis, modify the y value
  else if(selectAxis ==1){
    vertex.y = random(0, bHeight);}
  // If selecting z-axis, modify the z value
  else if(selectAxis ==2){
    vertex.z = random(0, bDepth);}
  return vertex;  
  
}
